#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    size_t number_count;
};

void
find_minmax(vector<double> numbers, double& min, double& max, size_t number_count) {
    min = numbers[0];
    max = numbers[0];
    for (size_t i = 1; i < number_count; i++ ){
        if(numbers[i] < min){
            min = numbers[i];
        }
        else if (numbers[i] > max){
            max = numbers[i];
        }
    }
}


Input input_data() {
    Input in;
    cin >> in.number_count;

    in.numbers.resize(in.number_count);
    for (size_t i = 0; i < in.number_count; i++) {
        cin >> in.numbers[i];
    }

    cin >> in.bin_count;
    return in;
}

int main(){
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    Input in = input_data();

    double minc, maxc;
    find_minmax(in.numbers, minc, maxc, in.number_count);

    vector<size_t> bins(in.bin_count);
    double bin_size = (maxc - minc) / in.bin_count;
    size_t bin_max_size = 0;
    for (size_t i = 0; i < in.number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < in.bin_count - 1) && !found; j++) {
            auto lo = minc + j * bin_size;
            auto hi = minc + (j + 1) * bin_size;
            if ((lo <= in.numbers[i]) && (in.numbers[i] < hi)) {
                bins[j]++;
                found = true;
                if (bins[j]> bin_max_size){
                    bin_max_size = bins[j];
                }
            }
        }
        if (!found) {
            bins[in.bin_count - 1]++;
            if (bins[in.bin_count - 1]> bin_max_size){
                    bin_max_size = bins[in.bin_count - 1];
                }
        }
    }
    size_t height;
    for(int i = 0; i<in.bin_count; i++){
        if(bins[i]<100){
            cout<<" ";
            if(bins[i]<10){
                cout<<" ";
            }
        }
        cout<<bins[i]<<"|";
        if(bin_max_size >= MAX_ASTERISK){
            height = floor(static_cast<double>(bins[i])*76.0f/static_cast<double>(bin_max_size));
        } else {
            height = bins[i];
        }
        for(int j = 0; j<height; j++){
            cout<<"*";
        }

        cout<<endl;
    }

    return 0;
}
